/* indybot - Copyright (C) 2004 bakunin - <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include <indybot.h>

struct channel *
add_channel (const char *chan)
{
  struct channel *tmp;

  if (!chan)
    fatal ("Error in config files o internal error.");

  if (!(tmp = (struct channel *) malloc (sizeof (struct channel))))
    fatal ("Error: memory.");
  memset (tmp, 0, sizeof (struct channel));

  if (*chan == '#')
    {
      if (!(tmp->channel = strdup (chan)))
	fatal ("Error: memory.");
    }
  else
    {
      if (!
	  (tmp->channel =
	   (char *) malloc (sizeof (char) * (strlen (chan) + 2))))
	fatal ("Error: memory.");

      *tmp->channel = '#';
      memcpy (tmp->channel + 1, chan, strlen (chan));
      *(tmp->channel + strlen (chan) + 2) = 0;
    }

  tmp->next = channels;

  channels = tmp;

  return tmp;
}

void
add_channel_file (struct channel *chan, char *file)
{
  struct file *tmp;

  if (!(tmp = (struct file *) malloc (sizeof (struct file))))
    fatal ("Error: memory.");

  memset (tmp, 0, sizeof (struct file));

  if (!strncmp (file, "http", 4))
    {
      if (!(tmp->file = strdup (file)))
	fatal ("Error: memory.");

    }
  else
    {
      if (!
	  (tmp->file = (char *) malloc (sizeof (char) * (strlen (file) + 7))))
	fatal ("Error: memory.");

      sprintf (tmp->file, "http://%s", file);

    }

  tmp->next = chan->files;
  chan->files = tmp;
}

/* EOF */
